<? //Interbase installation - tables definition

	function isTableExists($tableName) {
		$q=db_query("SELECT COUNT(*) FROM \"RDB\$RELATIONS\" WHERE \"RDB\$RELATION_NAME\" = '".strtoupper($tableName)."'");
		if ($r=db_fetch_row($q)) {
			return $r[0]==1;
		} else {
			return false;
		}
	}

	if (!isTableExists(ORDERS_TABLE)) {
		db_query("CREATE GENERATOR ORDERS_GEN");
		db_query("CREATE TABLE ".ORDERS_TABLE." (orderID INTEGER NOT NULL PRIMARY KEY, order_time TIMESTAMP, cust_firstname VARCHAR(30), cust_lastname VARCHAR(30), cust_email VARCHAR(30), cust_country VARCHAR(30), cust_zip VARCHAR(30), cust_state VARCHAR(30), cust_city VARCHAR(30), cust_address VARCHAR(30), cust_phone VARCHAR(30))") or die (db_error());
		db_query("CREATE TRIGGER ORDERS_NEW FOR ".ORDERS_TABLE." ACTIVE BEFORE INSERT POSITION 0 AS begin if (new.orderID is null) then new.orderID = gen_id(ORDERS_GEN, 1); end" );
	}

	if (!isTableExists(ORDERED_CARTS_TABLE)) {
		db_query("CREATE TABLE ".ORDERED_CARTS_TABLE." (productID INTEGER NOT NULL, orderID INTEGER NOT NULL, name VARCHAR(255), Price double precision, Quantity INTEGER, PRIMARY KEY (productID, orderID))") or die (db_error());
	}

	if (!isTableExists(PRODUCTS_TABLE)) {
		db_query("CREATE TABLE ".PRODUCTS_TABLE." (productID INTEGER NOT NULL PRIMARY KEY, categoryID INTEGER, name VARCHAR(255), description VARCHAR(8192), customers_rating double precision NOT NULL, Price double precision, picture VARCHAR(30), in_stock INTEGER, thumbnail VARCHAR(30), customer_votes INTEGER NOT NULL, items_sold INTEGER NOT NULL, big_picture VARCHAR(30), enabled INTEGER, brief_description VARCHAR(8192), list_price double precision, product_code VARCHAR(25))") or die (db_error());
		db_query("CREATE GENERATOR PRODUCTS_GEN");
		db_query( "CREATE TRIGGER PRODUCTS_NEW FOR ".PRODUCTS_TABLE." ACTIVE BEFORE INSERT POSITION 0 AS begin if (new.productID is null) then new.productID = gen_id(PRODUCTS_GEN, 1); end" );
	}


	if (!isTableExists(CATEGORIES_TABLE)) {
		db_query("CREATE TABLE ".CATEGORIES_TABLE." (categoryID INTEGER NOT NULL PRIMARY KEY, name VARCHAR(255), parent INTEGER, products_count INTEGER, description VARCHAR(8192), picture VARCHAR(30), products_count_admin INTEGER)") or die (db_error());
		db_query("CREATE GENERATOR CATEGORIES_GEN");
		db_query( "CREATE TRIGGER CATEGORIES_NEW FOR ".CATEGORIES_TABLE." ACTIVE BEFORE INSERT POSITION 0 AS begin if (new.categoryID is null) then new.categoryID = gen_id(CATEGORIES_GEN, 1); end" );
	}


	if (!isTableExists(SPECIAL_OFFERS_TABLE)) {
		db_query("CREATE TABLE ".SPECIAL_OFFERS_TABLE." (offerID INTEGER NOT NULL PRIMARY KEY, productID INTEGER, sort_order INTEGER)") or die (db_error());
		db_query("CREATE GENERATOR SPECIAL_OFFERS_GEN");
		db_query( "CREATE TRIGGER SPECIAL_OFFERS_NEW FOR ".SPECIAL_OFFERS_TABLE." ACTIVE BEFORE INSERT POSITION 0 AS begin if (new.offerID is null) then new.offerID = gen_id(SPECIAL_OFFERS_GEN, 1); end" );
	}

?>